;
;	Intelligent Printer Font Handling. Release 1.00
;
;	Handler definitions.
;

IPF_VERSION	EQU 	0100H

ASCII_PAGE	equ	1
GRAPH_PAGE	equ	2
CYR_PAGE	equ	3

IPF_HEADER	macro	init,reset,print,buffer
		org	0
		dw	init	;	INIT entry
		dw	0,0     ;	FAR pointer to printer output routine
		dw	reset	;	RESET entry
		dw	print   ;	PRINT entry
		dw	0       ;	Current CONTROL entry
		dw	0       ;	End of control sequences table
		dw	buffer  ;	Buffer address
		dw	buffer  ;	Buffer fill pointer
		db	0	;	Fictive END-OF-TABLE
		endm

IPF_CONTROL	macro	code,entry
		org	$-1
		db	code
		dw	entry
		db	0
		endm

IPF_GROUP	macro	code
		org	$-1
		db	0FFh
		db	code
		__GSIZE = 1
		__GSLOC = $
		db	__GSIZE
		db	0
		db	0
		endm

__list_length	macro	list
		__LL = 0
		irp	__code,list
			__LL = __LL + 1
		endm
		endm

IPF_G_ENTRY	macro	list,entry
		org	$-2
		__list_length	<list>
		if	__LL ne 1
			db	0FFh
			__GSIZE = __GSIZE + 1
		endif
		irp	__code,list
			db	__code
			__GSIZE = __GSIZE + 1
		endm
		if	__LL ne 1
			db	0
			__GSIZE = __GSIZE + 1
		endif
		__GSIZE = __GSIZE + 2
		dw	entry
		__SLC = $
		org	__GSLOC
		db	__GSIZE
		org	__SLC
		db	0
		db	0
		endm

IPF_END_TABLE	macro
		__SLC = $
		org	0Ch
		dw	__SLC
		org	__SLC
		endm

IPF_PRINT_ENTRY	equ	2

IPF_PRINT	macro
		call	ds:dword ptr IPF_PRINT_ENTRY
		endm
